【动态规划】打家劫舍

动态规划的四个解题步骤:

cpp 复制代码
1、定义子问题
2、写出子问题的递推关系
3、确定dp数组的计算顺序
4、空间优化(可选)

上一篇博客学的有点杂乱,这一篇从解题步骤方面整理一下动态规划这一章。

打家劫舍(难度:中等)


该题对应力扣网址

(无语了,我第一次看到这道题,觉得太简单了,直接想间隔一间房子偷一次,代码不会写,小偷也不合格。。。。嘎嘎嘎)

步骤:
1、定义子问题

找到一个和原问题相似,但规模较小的问题

原问题:从所有房子中能偷到的最大金额

子问题:(规模缩小)从k个房子中能偷到的最大金额

要求子问题必须具备两个性质:

1️⃣原问题要能由子问题表示(当k=n时)

2️⃣一个子问题的解要能通过其他子问题的解求出(最优子结构)

2、子问题的递推关系

思路很重要,这道题的递推关系是,f(k)表示从前k个房子(0到k-1)中能偷到的最大金额。

偷k个房子有两种偷法:

1️⃣偷前k-1间房子,从0到k-2,最后一间不偷

2️⃣偷前k-2间和最后一间房子,从0到k-3,第k-2间不偷

这两种情况,需要选择金额较大的一种结果:

f(k)=max{f(k-1),H(k-1)+f(k-2)}

在写递推关系的同时,还要注意边界

当k=0和k=1的情况(根据公式得出边界取值)

f(0)=0 f(1)=H(0)

3、确定dp数组的计算顺序

动态规划有两种计算顺序,在上一篇博客中也说过,一种是自顶向上、使用备忘录的递归方法,另一种是自底向上、使用dp数组的循环方法。(之前还说过一种方法,就是自顶向上、不使用备忘录的递归方法,不过因为不用备忘录所以存在时间超出限制的情况,就说是有两种方法)

不过因为博主说大多数普通动态规划题目都不需要用到备忘录方法,所以还是使用自底向上的dp数组。

dp数组(子问题数组)的每一个元素都对应一个子问题,例如:dpk对应f(k),即偷前k间房子的最大金额。

dpk=max(dpk-1,H(k-1)+dpk-2)

4、空间优化(可选)

属于是在空间上做进一步优化,因为f(k)只依赖f(k-1)和f(k-2)两个结果,所以可以用变量保存着两个子问题的结果。空间复杂度从O(n)降到了O(1)。

AC代码

cpp 复制代码
class Solution {
public:
    int rob(vector<int>& nums) {
        //动态规划,自底向上dp数组
        int len=nums.size();
        vector <int> dp(len+1,0);
        //init base case
        dp[0]=0;
        dp[1]=nums[0];
        
        //对于每一个状态
        for(int i=2;i<=len;i++){
            dp[i]=max(dp[i-1],nums[i-1]+dp[i-2]);
        }
        return dp[len];
    }
};

这个方法是自底向上的dp数组,没有进行空间优化,如果要进行空间优化的话,也挺简单的,就是把dp数组换成俩变量就行了。

动态规划这块儿有点难了,慢慢来吧(略略略...)

相关推荐
蜗牛一步步往上爬2 分钟前
第十六章 C++语言在深度学习中的应用
开发语言·c++·深度学习
likexuec2 小时前
数据结构(2)
数据结构
Navigator_Z3 小时前
LeetCode //C - 1317. Convert Integer to the Sum of Two No-Zero Integers
c语言·算法·leetcode
wo_jack4 小时前
C++ 入门笔记(十六):第16课 vector 模拟实现十问十答 —— 从三指针到迭代器失效
c++·后端·面试·stl·vector
D e re k ZH4 小时前
C++ 标准库算法全景指南
数据结构·c++·算法
冻柠檬飞冰走茶5 小时前
字母移动游戏题解:贪心求最长可保留连续子串(附 C 实现)
c语言·开发语言·数据结构·算法·动态规划
雪落漂泊5 小时前
C++算法 二分查找篇(上)
开发语言·c++·算法
不会算法的笨小孩7 小时前
异常的使用以及会出现的问题
开发语言·c++·c++11·异常
LabVIEW开发7 小时前
LabVIEW 连接板:28 个端子怎么排,优先级怎么定
java·算法·labview